<xsl:stylesheet version="1.0" 
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  
				xmlns:xs="http://www.w3.org/2001/XMLSchema"  
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:ui="http://java.sun.com/jsf/facelets"
				xmlns:h="http://java.sun.com/jsf/html"
				xmlns:f="http://java.sun.com/jsf/core"
				xmlns:c="http://java.sun.com/jsp/jstl/core"
				xmlns:fmt="http://java.sun.com/jsp/jstl/fmt"
				xmlns:to="http://myfaces.apache.org/tomahawk"
				xmlns:html="http://www.w3.org/1999/xhtml"
				>

<xsl:output method="xml" indent="yes"/>
<xsl:strip-space elements="h1 h2 body" />
<xsl:template match="/">
	<html xmlns="http://www.w3.org/1999/xhtml"
			xmlns:ui="http://java.sun.com/jsf/facelets"
			xmlns:h="http://java.sun.com/jsf/html"
			xmlns:f="http://java.sun.com/jsf/core"
			xmlns:c="http://java.sun.com/jsp/jstl/core"
			xmlns:fmt="http://java.sun.com/jsp/jstl/fmt"
			xmlns:to="http://myfaces.apache.org/tomahawk"
			>
		<body>
				<f:loadBundle basename="messages"  var="msg" />
					<ui:composition template="../template.xhtml">
						<xsl:apply-templates />
					</ui:composition>
				
		</body>
	</html>
</xsl:template>

<xsl:template match="funcion">
	<xsl:variable name="fname" select="name" ></xsl:variable>
	<ui:define name="title">
		<xsl:text disable-output-escaping="yes" >&lt;h:outputText value="#{msg.function</xsl:text><xsl:value-of select="name" /><xsl:text disable-output-escaping="yes" >}" /&gt;</xsl:text>						
	</ui:define>			
	<ui:define name="ruta">
		<xsl:text disable-output-escaping="yes" >&lt;h:outputText value="#{msg.function</xsl:text><xsl:value-of select="name" /><xsl:text disable-output-escaping="yes" >}" /&gt;</xsl:text>						
	</ui:define>			
		<xsl:apply-templates select="fields" />
</xsl:template>
			
<xsl:template match="fields" >

	<ui:define name="search">
		<!--  ... Search Block ...  -->
		<xsl:text disable-output-escaping="yes" >&lt;h:panelGroup rendered="#{!</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.formView}" &gt;</xsl:text>
			<xsl:text disable-output-escaping="yes" >&lt;fieldset&gt;</xsl:text>					
				
				
				<xsl:for-each select="./field">
					<xsl:apply-templates  mode="searchfield" select="."/>
				</xsl:for-each>
				
				<xsl:apply-templates  mode="searchfieldgroup" select="group"  />
				
				<h:panelGroup styleClass="searchForm" > 
					<xsl:text disable-output-escaping="yes" >
						&lt;h:commandButton actionListener="#{</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.cancel}" value="#{msg.reset}" /&gt;
					</xsl:text>
					<xsl:text disable-output-escaping="yes" >
						&lt;h:commandButton actionListener="#{</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.search}" value="#{msg.search}" /&gt;
					</xsl:text>
				</h:panelGroup>
				<xsl:text disable-output-escaping="yes" >&lt;/fieldset&gt;</xsl:text>
			<xsl:text disable-output-escaping="yes" >&lt;/h:panelGroup&gt;</xsl:text>

		</ui:define>
		
		
		<ui:define name="list">
			<xsl:text disable-output-escaping="yes" >
				&lt;h:panelGroup id="botonera" rendered="#{!</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.formView}" &gt;
			</xsl:text>
			<xsl:text disable-output-escaping="yes" >&lt;fieldset&gt;</xsl:text>
			<xsl:text disable-output-escaping="yes" >
				&lt;h:dataTable value="#{</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.model}" var="iter" id="table" rows="8" &gt;
			</xsl:text>
			<xsl:apply-templates mode="tablefield" />
			<h:column>
				<xsl:text disable-output-escaping="yes" >
					&lt;f:facet name="header"&gt;
					&lt;h:outputText value=" "  /&gt;
					&lt;/f:facet&gt;
				</xsl:text>
				<xsl:text disable-output-escaping="yes" >&lt;h:commandButton value="#{msg.edit}" actionListener="#{</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.preUpdate}" /&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes" >&lt;h:commandButton value="#{msg.delete}" actionListener="#{</xsl:text><xsl:value-of select="../name"/><xsl:text disable-output-escaping="yes" >s.preDelete}" /&gt;</xsl:text>
		</h:column>
	<xsl:text disable-output-escaping="yes" >&lt;/h:dataTable&gt;</xsl:text>
	<to:dataScroller id="scroll" for="table" fastStep="10" pageCountVar="paginas" 
									pageIndexVar="indice" paginator="true" immediate="true">
				
		<f:facet name="first">
			<h:outputText value="first" />
		</f:facet>
		<f:facet name="last">
			<h:outputText value="last" />
		</f:facet>
	</to:dataScroller> 
	<xsl:text disable-output-escaping="yes" >&lt;h:commandButton value="crear" actionListener="#{</xsl:text>
	<xsl:value-of select="../name" />
	<xsl:text disable-output-escaping="yes">s.preCreate}" /&gt;</xsl:text>
	<xsl:text disable-output-escaping="yes" >&lt;/fieldset&gt;</xsl:text>
	<xsl:text disable-output-escaping="yes" >&lt;/h:panelGroup&gt;</xsl:text>
</ui:define>
	
	
<ui:define name="form">
	<xsl:text disable-output-escaping="yes" >&lt;h:panelGroup rendered="#{</xsl:text>
			<xsl:value-of select="../name" />
			<xsl:text disable-output-escaping="yes" >s.formView}"&gt;</xsl:text>
			
				<xsl:text disable-output-escaping="yes" >&lt;fieldset&gt;</xsl:text>
					
					<xsl:for-each select="./field">
						<xsl:apply-templates  mode="formfield" select="."/>
					</xsl:for-each>
				
					<xsl:apply-templates  mode="formfieldgroup" select="group"  />
				
						<xsl:text disable-output-escaping="yes" >&lt;br/&gt;</xsl:text>
					
						<xsl:text disable-output-escaping="yes" >
							&lt;h:commandButton value="#{msg.cancel}" actionListener="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.cancel}" /&gt;
							
						</xsl:text>
						
						<xsl:text disable-output-escaping="yes" >
							&lt;h:commandButton value="#{msg.create}" actionListener="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.create}" rendered="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.operation eq 0}" /&gt;
						</xsl:text>
	
						<xsl:text disable-output-escaping="yes" >
							&lt;h:commandButton value="#{msg.accept}" actionListener="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.read}" rendered="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.operation eq 1}" /&gt; 
						</xsl:text>
				
						<xsl:text disable-output-escaping="yes" >
							&lt;h:commandButton value="#{msg.update}" actionListener="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.update}" rendered="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.operation eq 2}" /&gt;
							
						</xsl:text>
				
						<xsl:text disable-output-escaping="yes" >
							&lt;h:commandButton value="#{msg.delete}" actionListener="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.delete}" rendered="#{</xsl:text><xsl:value-of select="../name" /><xsl:text disable-output-escaping="yes" >s.operation eq 3}" /&gt;
						</xsl:text>

				<xsl:text disable-output-escaping="yes" >&lt;/fieldset&gt;</xsl:text>			
			<xsl:text disable-output-escaping="yes" >&lt;/h:panelGroup&gt;</xsl:text>
			
		</ui:define>	
	</xsl:template>

	<xsl:template  name="searchfieldgroup" mode="searchfieldgroup" match="group">	
		<h:panelGroup styleClass="searchfieldgroup" >
				<xsl:apply-templates  mode="searchfield" select="field"/>
		</h:panelGroup>
	</xsl:template>				
				
	<xsl:template  name="searchfield" mode="searchfield" match="field">	
		<h:panelGroup styleClass="searchfield" >
			<xsl:text disable-output-escaping="yes" >
				&lt;h:outputLabel for="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field"  value=" #{msg.</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >} : " &gt;
			</xsl:text>
			<xsl:text disable-output-escaping="yes" >&lt;/h:outputLabel&gt;</xsl:text>
			<xsl:choose>
			
					<xsl:when test='@display="combo"' >
									<xsl:text disable-output-escaping="yes" >&lt;h:selectOneMenu id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field" value="#{</xsl:text><xsl:value-of select="../../name" /><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;
											&lt;f:selectItems value="#{combo</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >.data}" /&gt;
											&lt;f:converter converterId="DtoIdComboConverter" /&gt;
													&lt;f:attribute name="className" value="</xsl:text><xsl:value-of select="@className"/><xsl:text disable-output-escaping="yes" >" /&gt;
													&lt;f:attribute name="idField" value="</xsl:text><xsl:value-of select="@idField"/><xsl:text disable-output-escaping="yes" >" /&gt;
													&lt;f:attribute name="nameField" value="</xsl:text><xsl:value-of select="@nameField"/><xsl:text disable-output-escaping="yes" >" /&gt;
									&lt;/h:selectOneMenu &gt;</xsl:text>
					</xsl:when>
					<xsl:when  test="(type='java.util.Date') or (type='java.sql.Date') " >
						<xsl:text disable-output-escaping="yes" >&lt;h:inputText id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field" value="#{</xsl:text><xsl:value-of select="../../name" /><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;&lt;/h:inputText &gt;</xsl:text>
				</xsl:when>
				<xsl:when  test="(type='java.lang.Boolean')" >
					<xsl:text disable-output-escaping="yes" >&lt;h:selectBooleanCheckbox id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field" value="#{</xsl:text><xsl:value-of select="../../name" /><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;&lt;/h:selectBooleanCheckbox &gt;</xsl:text>
				</xsl:when>
				<xsl:when  test="(type='java.lang.Float') or (type='java.lang.Integer') or (type='java.lang.Long')  " >
					<xsl:text disable-output-escaping="yes" >&lt;h:inputText id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field" value="#{</xsl:text><xsl:value-of select="../../name" /><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;&lt;f:convertNumber/&gt;&lt;/h:inputText &gt;</xsl:text>
				</xsl:when>
				
				<xsl:otherwise >
					<xsl:text disable-output-escaping="yes" >&lt;h:inputText id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field" value="#{</xsl:text><xsl:value-of select="../../name" /><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;&lt;/h:inputText &gt;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		
			<!--   <xsl:value-of select="type"/> -->
			<xsl:text disable-output-escaping="yes" >&lt;h:message for="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >field"&gt;&lt;/h:message&gt;</xsl:text>
		</h:panelGroup> 
					
	</xsl:template>

	<xsl:template  name="tablefield"  mode="tablefield" match="field">
		<h:column>
			<xsl:text disable-output-escaping="yes" >
				&lt;f:facet name="header"&gt;
					&lt;h:outputText value=" #{msg.</xsl:text><xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"  /&gt;
				&lt;/f:facet&gt;
			</xsl:text>
			<xsl:text disable-output-escaping="yes" >
				&lt;h:outputText value="#{iter.</xsl:text><xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;</xsl:text>
						<!--  ............ Pendiente de chequear ........................
						<xsl:if test="(type='java.lang.Boolean')" >
								<xsl:text disable-output-escaping="yes" >
								&lt;h:selectBooleanCheckbox readOnly="true" id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name"/><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"&gt;&lt;/h:selectBooleanCheckbox&gt;
							</xsl:text>
						</xsl:if> -->
						<xsl:if test='@display="combo"' >
							<xsl:text disable-output-escaping="yes" >									
								&lt;f:converter converterId="DtoIdComboConverter" /&gt;
								&lt;f:attribute name="className" value="</xsl:text><xsl:value-of select="@className"/><xsl:text disable-output-escaping="yes" >" /&gt;
								&lt;f:attribute name="idField" value="</xsl:text><xsl:value-of select="@idField"/><xsl:text disable-output-escaping="yes" >" /&gt;	
							</xsl:text>
						</xsl:if><xsl:text disable-output-escaping="yes" >&lt;/h:outputText &gt;</xsl:text>
				<!--  Pendiente (link)
				<h:commandLink actionListener="#{tiposuperficie.choose}" value="#{iter.superficie.nombre}"  
				onclick="location='../tiposuperficie/page.jsf';return false;" 
				>
				<h:inputHidden value="#{iter.superficie.id}" binding="#{tiposuperficies.uiinput}"></h:inputHidden>		
				</h:commandLink>
				 -->
						
		</h:column>			
	</xsl:template>

	<xsl:template  name="formfieldgroup" mode="formfieldgroup" match="group">	
		<h:panelGroup styleClass="formfieldgroup" >
			<xsl:apply-templates  mode="formfield" select="field" />
		</h:panelGroup>
	</xsl:template>				

	<xsl:template  name="formfield" mode="formfield" match="field">		
		<h:panelGroup styleClass="formfield" >
			<xsl:text disable-output-escaping="yes" >
				&lt;h:outputLabel for="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform"  value=" #{msg.</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >} : "  &gt;
			</xsl:text>
			<xsl:text disable-output-escaping="yes" >&lt;/h:outputLabel&gt;</xsl:text>
			<xsl:choose>
				<xsl:when test='@display="combo"' >
									<xsl:text disable-output-escaping="yes" >&lt;h:selectOneMenu id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name" />s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}" &gt;
											&lt;f:selectItems value="#{combo</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >.data}" /&gt;
											&lt;f:converter converterId="DtoIdComboConverter" /&gt;
													&lt;f:attribute name="className" value="</xsl:text><xsl:value-of select="@className"/><xsl:text disable-output-escaping="yes" >" /&gt;
													&lt;f:attribute name="idField" value="</xsl:text><xsl:value-of select="@idField"/><xsl:text disable-output-escaping="yes" >" /&gt;
													&lt;f:attribute name="nameField" value="</xsl:text><xsl:value-of select="@nameField"/><xsl:text disable-output-escaping="yes" >" /&gt;
										
									&lt;/h:selectOneMenu &gt;</xsl:text>
				</xsl:when>	
				<xsl:when  test="(type='java.util.Date') or (type='java.sql.Date') or (type='java.util.Calendar') or  (type='java.util.GregorianCalendar')" >
					<xsl:text disable-output-escaping="yes" >
						&lt;to:inputCalendar id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name"/><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"&gt;&lt;/to:inputCalendar&gt;
					</xsl:text>
				</xsl:when>
				<xsl:when  test="(type='java.lang.Boolean')" >
					<xsl:text disable-output-escaping="yes" >
						&lt;h:selectBooleanCheckbox id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name"/><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"&gt;&lt;/h:selectBooleanCheckbox&gt;
					</xsl:text>
				</xsl:when>
				<xsl:when  test="(type='java.lang.Float') or (type='java.lang.Integer') or (type='java.lang.Long')  " >
					<xsl:text disable-output-escaping="yes" >
						&lt;h:inputText id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name"/><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"&gt; &lt;f:convertNumber/&gt;&lt;/h:inputText&gt;
				
					</xsl:text>	
				</xsl:when>				
				<xsl:otherwise>
					<xsl:text disable-output-escaping="yes" >
						&lt;h:inputText id="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform" value="#{</xsl:text><xsl:value-of select="../../name"/><xsl:value-of select="../../../name"/>s.dto.<xsl:value-of select="name"/><xsl:text disable-output-escaping="yes" >}"&gt;&lt;/h:inputText&gt;
					</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text disable-output-escaping="yes" >
				&lt;h:message for="</xsl:text><xsl:value-of select="translate(name, '.', '')"/><xsl:text disable-output-escaping="yes" >fieldform"&gt;&lt;/h:message&gt;
			</xsl:text>
		</h:panelGroup> 
	</xsl:template>
</xsl:stylesheet>